



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[日常] Go语言圣经--示例: 并发的Echo服务</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[日常] Go语言圣经--示例: 并发的Echo服务</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-19 07:56:24 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>最简单的回声服务器：</strong></p>
<div>
<pre class="prettyprint linenums">package main

import (<br />
        "io"<br />
        "net"<br />
        "log"<br />
)

func main() {<br />
        listener, err := net.Listen("tcp", ":8040")<br />
        if err != nil {<br />
                log.Fatal(err)<br />
        }   

        for {<br />
                conn, err := listener.Accept()<br />
                if err != nil {<br />
                        log.Print(err) // e.g., connection aborted<br />
                        continue<br />
                }<br />
                go handleConn(conn) //新建goroutines处理连接<br />
        }<br />
}

func handleConn(c net.Conn) {<br />
    io.Copy(c, c) // NOTE: ignoring errors<br />
    c.Close()<br />
}
</pre>
</div>
<p>原理：</p>
<p><strong>1.io.Copy()方法</strong><br />func Copy(dst Writer, src Reader) (written int64, err error)</p>
<p><strong>2.net.Conn类型</strong><br />type Conn interface {<br />    Read(b []byte) (n int, err error)<br />    Write(b []byte) (n int, err error)<br />    ...<br />}<br />一个类型如果拥有一个接口需要的所有方法，那么这个类型就实现了这个接口</p>
<p><strong>3.io.Writer</strong><br />type Writer interface {<br />    Write(p []byte) (n int, err error)<br />}<br /><strong>4.io.Reader</strong><br />type Reader interface {<br />    Read(p []byte) (n int, err error)<br />}</p>
<p><strong>升级版，每条连接一个goroutine,每个goroutine中分出多个输出goroutine</strong></p>
<div>
<pre class="prettyprint linenums">package main

import (<br />
        "bufio"<br />
        "fmt"<br />
        "log"<br />
        "net"<br />
        "strings"<br />
        "time"<br />
)

func main() {<br />
        listener, err := net.Listen("tcp", ":8040")<br />
        if err != nil {<br />
                log.Fatal(err)<br />
        }   

        for {<br />
                conn, err := listener.Accept()<br />
                if err != nil {<br />
                        log.Print(err) // e.g., connection aborted<br />
                        continue<br />
                }<br />
                go handleConn(conn) //新建goroutines处理连接<br />
        }<br />
}

func handleConn(c net.Conn) {<br />
        input := bufio.NewScanner(c)<br />
        for input.Scan() {<br />
                go echo(c, input.Text(), 1*time.Second)<br />
        }<br />
        // NOTE: ignoring potential errors from input.Err()<br />
        c.Close()<br />
}<br />
func echo(c net.Conn, shout string, delay time.Duration) {<br />
        fmt.Fprintln(c, "\t", strings.ToUpper(shout))<br />
        time.Sleep(delay)<br />
        fmt.Fprintln(c, "\t", shout)<br />
        time.Sleep(delay)<br />
        fmt.Fprintln(c, "\t", strings.ToLower(shout))<br />
}
</pre>
</div>
<p>　　</p>
<p><strong>1.fmt.Fprintln()</strong><br />func Fprintln(w io.Writer, a ...interface{}) (n int, err error)</p>
<p><strong>2.bufio.NewScanner()</strong><br />    func NewScanner(r io.Reader) *Scanner<br />    func (s *Scanner) Scan() bool<br />    func (s *Scanner) Text() string</p>
<p>也用到了大量的7.3节 实现接口的条件</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/726254/201804/726254-20180427223740466-93752089.jpg" />　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8e1gnk9.html">解决virtualbox装ghost xp装驱动时报portcls&period;sys蓝屏的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/390vwmn8.html">python基础知识（三）</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy2l029.html">Ubuntu 配置有线网 IP</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7g12gq.html">windows系统下在dos命令行kill掉被占用的pid &lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq107328.html">安装最新版本的ReSharper导致原生全局搜索工具的消失问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q74wnkq.html">Android中几种定位 方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvvoy1q.html">VBA对象模型（2）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0zd1gq.html">第三个sprint第一天</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydgvrxq.html">Java中的10颗语法糖</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn10z3k8.html">C&num;基础知识-对象初始化顺序</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w1onxq.html">MySQL数据库服务器 主从配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1o5pj8.html">&lbrack;实战&rsqb;记一次PUT方法拿下网站shell</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjzvkk9.html">JLINK烧写BIN文件到nand、norflash、SDRAM</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okxk0x9.html">不要将 Array、Object 等类型指定给 prototype</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zm5gk9.html">MVC之Session State性能</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg11me8.html">Archive for required library&colon;xxxxx&sol;spring-beans-3&period;2&period;4&period;RELEASE&period;jar in project XXXXX cannot be read or is not a valid ZIP file</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdopod9.html">git 上传代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv0z5k8.html">C&plus;&plus; LocalAlloc&lpar;&rpar; &amp;amp&semi; LocalSize&lpar;&rpar; &amp;amp&semi; LocalFree &lpar;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e47d4m9.html">C&num; byte数组与Image的相互转换【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o5m418.html">hihoCoder 1145 幻想乡的日常（树状数组 &plus; 离线处理）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8zymzmv9.html">python实现Telnet远程登陆到设备并执行命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2x46x9.html">【BZOJ4827】 &lbrack;Hnoi2017&rsqb;礼物</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnv37v38.html">Android---------------Activity的学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25roolq.html">jzoj4223</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25rorlq.html">前端基础-html  字体标签&comma;排版标签&comma;超链接&comma;图片标签</a>
			</li>
						<li><a href="https://www.batexi.com/a/960117n9.html">TmsHttpClientUtil</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyype5gq.html">MySQL utilities介绍&amp;amp&semi;出现 No module named utilities</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kj30p39.html">Python小白学习之路（二十六）&mdash;【if &lowbar;&lowbar;name&lowbar;&lowbar; &equals;&equals;&amp;&num;39&semi;&lowbar;&lowbar;main&lowbar;&lowbar;&amp;&num;39&semi;&colon;】【用状态标识操作】</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllzmweq.html">vue教程2-07 自定义指令</a>
			</li>
						<li><a href="https://www.batexi.com/a/93w0xmzq.html">mvn cli 搭建项目架构</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
